<script setup lang="ts">
import PendingDialog from '../components/PendingDialog.vue'
import { usePayrollStore } from '../stores/payroll'
import PayrollDetail from '../components/PayrollDetail.vue'
import PayrollDetailView from '../components/PayrollDetailView.vue'
import { onMounted } from 'vue'
import TableLayout from '@/layouts/TableLayout.vue'
import { usePayrollDetailStore } from '../stores/payrollDetail'

const payrollStore = usePayrollStore()
const payrollDetailStore = usePayrollDetailStore()

onMounted(async () => {
  await payrollStore.reloadPayroll()
})
</script>
<template>
  <TableLayout
    title="Payroll Management"
    has-action
    :items="payrollStore.items"
    :headers="payrollStore.headers"
    sort-by="id"
    sort-desc
  >
    <template #topCardText>
      <v-row>
        <v-col cols="8"> </v-col>
        <v-col cols="2" class="d-flex justify-end">
          <v-btn
            prepend-icon="mdi-printer"
            color="#FFD180"
            rounded="xl"
            class="overflow-hidden"
            :disabled="payrollStore.items.length === 0"
            min-width="150"
            @click="payrollStore.downloadPDF()"
            >Download PDF
          </v-btn>
        </v-col>
        <v-col cols="2" class="d-flex justify-end">
          <v-btn
            prepend-icon="mdi-plus"
            color="#FFD180"
            rounded="xl"
            class="w-100"
            min-width="100"
            @click="payrollStore.openDialog()"
            >New</v-btn
          >
        </v-col>
      </v-row>
    </template>
    <template #actions="{ item }">
      <v-menu>
        <template v-slot:activator="{ props }">
          <v-btn v-bind="props" icon="mdi-dots-vertical"> </v-btn>
        </template>
        <v-card rounded="lg">
          <v-list>
            <v-list-item
              prepend-icon="mdi-eye"
              title="View more"
              @click="payrollDetailStore.openDialogDetailView(item)"
            >
            </v-list-item>
            <v-list-item
              prepend-icon="mdi-printer"
              title="Download PDF"
              @click="payrollStore.downloadOnePDF(item)"
            >
            </v-list-item>
            <v-list-item
              prepend-icon="mdi-delete"
              title="Delete"
              @click="payrollStore.deleteItem(item)"
            >
            </v-list-item>
          </v-list>
        </v-card>
      </v-menu>
    </template>
  </TableLayout>
  <PendingDialog />
  <PayrollDetail />
  <PayrollDetailView />
</template>
